<template>
  <q-page padding>
    <components-cylinder-details :request="true"/>
    <q-form class="q-mt-md" @submit="createNewRequest">
      <span class="row text-h5 q-pt-md">Contact Details</span>
      <div class="row justify-center q-gutter-md">
        <q-input
          v-model="name"
          label="Your name"
          :rules="[ val => val && val.length > 0 || 'Please enter the name.']"
        />

        <q-input
          v-model="phone"
          label="Your phone number"
          :rules="[ val => val && val.length === 10 || 'Please enter the phone.']"
        >
          <template v-slot:prepend>
            <span class="text-p">+91</span>
          </template>
        </q-input>

        <q-input
          v-model.number="quantity"
          label="Quantity"
          type="number"
        />
      </div>

      <span class="row text-h5 q-pt-md">Location</span>
      <div class="row justify-center q-gutter-md">
        <q-select
          use-input
          :behavior="$q.platform.is.ios === true ? 'dialog' : 'menu'"
          v-model="state"
          :options="states"
          label="State"
          :rules="[ val => val && val.isoCode.length > 0 || 'Please choose a state.']"
        />

        <q-select
          use-input
          :behavior="$q.platform.is.ios === true ? 'dialog' : 'menu'"
          v-model="city"
          :options="cities"
          label="City"
          :rules="[ val => val && val.length > 0 || 'Please choose a city.']"
        />

        <q-input
          v-model="pincode"
          label="Pincode"
          :rules="[ val => val && val.length > 0 || 'Please enter the phone.']"
        />
      </div>

      <q-banner class="bg-info text-white q-my-sm">
        Please do not make any financial transations before you receive the supplies. We are receiving very high number of sporadic requests from all over India. As a result, we cannot verify each person.
      </q-banner>

      <div class="row justify-end">
        <q-btn
          color="primary"
          label="Submit"
          type="submit"
        />
      </div>
    </q-form>
  </q-page>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api'
import ComponentsCylinderDetails from 'components/CylinderDetails'
import csc from 'country-state-city'

export default defineComponent({
  name: 'PageCreateCylinderRequest',

  components: {
    ComponentsCylinderDetails
  },

  data () {
    return {
      name: '',
      phone: '',
      quantity: 0,
      state: {
        label: '',
        value: '',
        isoCode: ''
      },
      city: '',
      pincode: ''
    }
  },

  computed: {
    states () {
      return csc.getStatesOfCountry('IN').map((item) => {
        return {
          label: item.name,
          value: item.name,
          isoCode: item.isoCode
        }
      })
    },

    cities () {
      if (this.state) {
        return csc.getCitiesOfState('IN', this.state.isoCode).map((item) => {
          return item.name
        })
      } else {
        return []
      }
    }
  },

  methods: {
    createNewRequest: function () {
      const cylinderID = this.$route.params.id
      this.postCylinderIDRequest(cylinderID)
        .then((response) => {
          if (response) {
            this.notifyCylinderRequestUpdate('Your request has been registered. The owner will contact you soon', 'info')
            this.$router.push('/')
          }
        })
        .catch((error) => {
          console.log(error)
          this.notifyCylinderRequestUpdate(error.response.data.message, 'warning')
        })
    },

    postCylinderIDRequest: function (cylinderID: string) {
      const payload = {
        rp_name: this.name,
        rp_phone: this.phone,
        rp_quantity: this.quantity,
        rp_state: this.state.value,
        rp_city: this.city,
        rp_pincode: parseInt(this.pincode),
        comment: 'Request generated'
      }
      return this.$axios.post(`/api/cylinders/${cylinderID}/requests`, payload)
    },

    notifyCylinderRequestUpdate (msg: string, color: string) {
      this.$q.notify({
        message: msg,
        color: color
      })
    }
  }
})
</script>
